#pragma semicolon 1
#pragma newdecls required

#include <sdkhooks>
#include <knife_arena>

public Plugin myinfo = 
{
	name	= "Knife Arena [Hide Players]",
	author	= "wS",
	version = "1.0.2"
};

bool g_bOnArena[MAXPLAYERS + 1] = {false, ...};
bool g_bBot[MAXPLAYERS + 1] = {false, ...};

public void OnPluginStart()
{
	HookEvent("round_start", Event_round_start, EventHookMode_PostNoCopy);
	
	KA_HookEvent(KA_OnPushFromQueueToArenaPost, OnPushFromQueueToArenaPost);
	KA_HookEvent(KA_OnArenaClientRemoved, OnArenaClientRemoved);
	
	for (int i = 0; ++i <= MaxClients;) {
		if (IsClientInGame(i)) {
			OnClientPutInServer(i);
		}
	}
}

static void Event_round_start(Event event, const char[] name, bool dontBroadcast)
{
	for (int i = 0; ++i <= MaxClients;) {
		g_bOnArena[i] = false;
	}
}

/////

static void OnPushFromQueueToArenaPost(int client)
{
	g_bOnArena[client] = true;
}

static void OnArenaClientRemoved(int client, KA_Reason reason)
{
	g_bOnArena[client] = false;
}

/////

public void OnClientPutInServer(int client)
{
	g_bBot[client] = IsFakeClient(client);
	
	SDKUnhook(client, SDKHook_SetTransmit, OnSetTransmit);
	SDKHook  (client, SDKHook_SetTransmit, OnSetTransmit);
}

public void OnClientDisconnect_Post(int client)
{
	g_bOnArena[client] = g_bBot[client] = false;
}

/////

//	- Если игрок (client)    на арене, то он не будет видеть тех, кто НЕ на ней.
//	- Если бот   (client) НЕ на арене, то он не будет видеть тех, кто    на ней (чтобы не стрелял).
static Action OnSetTransmit(int hooked_entity, int client)
{
	return ((g_bOnArena[client] && !g_bOnArena[hooked_entity]) || (g_bOnArena[hooked_entity] && g_bBot[client] && !g_bOnArena[client])) ? Plugin_Handled : Plugin_Continue;
}